(* $Id: oformat.ml,v 1.3 1998/09/01 09:31:28 garrigue Exp $ *)

open Format

class c fm = object
  val fm = fm
  method formatter = fm
  method open_hbox = pp_open_hbox fm ()
  method open_vbox = pp_open_vbox fm
  method open_hvbox = pp_open_hvbox fm
  method open_hovbox = pp_open_hovbox fm
  method open_box = pp_open_box fm
  method close_box = pp_close_box fm ()
  method string s ?:len =
    match len with None -> pp_print_string fm s
      	       	 | Some len -> pp_print_as fm :len s
  method int = pp_print_int fm
  method float = pp_print_float fm
  method char = pp_print_char fm
  method bool = pp_print_bool fm
  method break = pp_print_break fm
  method cut = pp_print_cut fm ()
  method space = pp_print_space fm ()
  method force_newline = pp_force_newline fm ()
  method flush = pp_print_flush fm ()
  method newline = pp_print_newline fm ()
  method if_newline = pp_print_if_newline fm ()
  method open_tbox = pp_open_tbox fm ()
  method close_tbox = pp_close_tbox fm ()
  method tbreak = pp_print_tbreak fm
  method set_tab = pp_set_tab fm ()
  method tab = pp_print_tab fm ()
  method set_margin = pp_set_margin fm
  method get_margin = pp_get_margin fm ()
  method set_max_indent = pp_set_max_indent fm
  method get_max_indent = pp_get_max_indent fm ()
  method set_max_boxes = pp_set_max_boxes fm
  method get_max_boxes = pp_get_max_boxes fm ()
  method set_ellipsis_text = pp_set_ellipsis_text fm
  method get_ellipsis_text = pp_get_ellipsis_text fm ()
  method set_formatter_out_channel = pp_set_formatter_out_channel fm
  method set_formatter_output_functions = pp_set_formatter_output_functions fm
  method get_formatter_output_functions =
      	 pp_get_formatter_output_functions fm ()
end

let create :out :flush = new c (make_formatter :out :flush)
let of_channel oc = create out:(output oc) flush:(fun () -> flush oc)
let std = new c std_formatter
