(* $Id: oset.mli,v 1.10 1999/04/30 07:53:43 garrigue Exp $ *)

type 'a t

class ['a] c : 'a list -> ?compare:('a -> 'a -> int) -> object ('b)
      (* [new c elements :compare] creates a set using comparison
      	 function compare and initializes it to elements.
	 This set is imperative, but you may take copies *)
  method contents : 'a t
  method set : to:'b -> unit
      (* [s1#set to:s2] copies the state of s2 to s1 *)
  method clear : unit
      (* resets the state to empty *)
  method is_empty : bool
  method mem : 'a -> bool
  method add : 'a -> unit
  method remove : 'a -> unit
      (* add and remove modify the state *)
  method union : with:'b -> 'b
  method inter : with:'b -> 'b
  method diff : with:'b -> 'b
      (* union, inter and diff return a new set without side-effect *)
  method compare : with:'b -> int
  method equal : to:'b -> bool
  method iter : fun:('a -> unit) -> unit
  method cardinal : int
  method elements : 'a list
  method choose : 'a
end

class ['a] f : 'a list -> ?compare:('a -> 'a -> int) -> object ('b)
      (* functional version of Oset.c *)
  method contents : 'a t
  method is_empty : bool
  method mem : 'a -> bool
  method add : 'a -> 'b
  method remove : 'a -> 'b
  method union : with:'b -> 'b
  method inter : with:'b -> 'b
  method diff : with:'b -> 'b
  method compare : with:'b -> int
  method equal : to:'b -> bool
  method iter : fun:('a -> unit) -> unit
  method fold : fun:('a -> acc:'c -> 'c) -> acc:'c -> 'c
  method cardinal : int
  method elements : 'a list
  method choose : 'a
end
